#ifndef SETTINGS_H
#define SETTINGS_H

#include "enums.h"
#include <QSettings>
#include <QStringList>
#include <QSet>
#include <qplatformdefs.h>

class QNetworkProxy;
class QAuthenticator;

class Settings : public QSettings
{
    Q_OBJECT

    Q_PROPERTY(bool enableYouTube1080Playback
               READ enableYouTube1080Playback
               WRITE setEnableYouTube1080Playback
               NOTIFY enableYouTube1080PlaybackChanged)
    Q_PROPERTY(bool enableYouTube720Playback
               READ enableYouTube720Playback
               WRITE setEnableYouTube720Playback
               NOTIFY enableYouTube720PlaybackChanged)
    Q_PROPERTY(bool enableYouTube480Playback
               READ enableYouTube480Playback
               WRITE setEnableYouTube480Playback
               NOTIFY enableYouTube480PlaybackChanged)
    Q_PROPERTY(bool enableYouTube360Playback
               READ enableYouTube360Playback
               WRITE setEnableYouTube360Playback
               NOTIFY enableYouTube360PlaybackChanged)
    Q_PROPERTY(bool enableYouTubeNormalPlayback
               READ enableYouTubeNormalPlayback
               WRITE setEnableYouTubeNormalPlayback
               NOTIFY enableYouTubeNormalPlaybackChanged)
    Q_PROPERTY(bool enableYouTube240Playback
               READ enableYouTube240Playback
               WRITE setEnableYouTube240Playback
               NOTIFY enableYouTube240PlaybackChanged)
    Q_PROPERTY(bool enableYouTube1080Download
               READ enableYouTube1080Download
               WRITE setEnableYouTube1080Download
               NOTIFY enableYouTube1080DownloadChanged)
    Q_PROPERTY(bool enableYouTube720Download
               READ enableYouTube720Download
               WRITE setEnableYouTube720Download
               NOTIFY enableYouTube720DownloadChanged)
    Q_PROPERTY(bool enableYouTube480Download
               READ enableYouTube480Download
               WRITE setEnableYouTube480Download
               NOTIFY enableYouTube480DownloadChanged)
    Q_PROPERTY(bool enableYouTube360Download
               READ enableYouTube360Download
               WRITE setEnableYouTube360Download
               NOTIFY enableYouTube360DownloadChanged)
    Q_PROPERTY(bool enableYouTubeNormalDownload
               READ enableYouTubeNormalDownload
               WRITE setEnableYouTubeNormalDownload
               NOTIFY enableYouTubeNormalDownloadChanged)
    Q_PROPERTY(bool enableYouTube240Download
               READ enableYouTube240Download
               WRITE setEnableYouTube240Download
               NOTIFY enableYouTube240DownloadChanged)
    Q_PROPERTY(bool enableDailymotion1080Playback
               READ enableDailymotion1080Playback
               WRITE setEnableDailymotion1080Playback
               NOTIFY enableDailymotion1080PlaybackChanged)
    Q_PROPERTY(bool enableDailymotion720Playback
               READ enableDailymotion720Playback
               WRITE setEnableDailymotion720Playback
               NOTIFY enableDailymotion720PlaybackChanged)
    Q_PROPERTY(bool enableDailymotion480Playback
               READ enableDailymotion480Playback
               WRITE setEnableDailymotion480Playback
               NOTIFY enableDailymotion480PlaybackChanged)
    Q_PROPERTY(bool enableDailymotion384Playback
               READ enableDailymotion384Playback
               WRITE setEnableDailymotion384Playback
               NOTIFY enableDailymotion384PlaybackChanged)
    Q_PROPERTY(bool enableDailymotion1080Download
               READ enableDailymotion1080Download
               WRITE setEnableDailymotion1080Download
               NOTIFY enableDailymotion1080DownloadChanged)
    Q_PROPERTY(bool enableDailymotion720Download
               READ enableDailymotion720Download
               WRITE setEnableDailymotion720Download
               NOTIFY enableDailymotion720DownloadChanged)
    Q_PROPERTY(bool enableDailymotion480Download
               READ enableDailymotion480Download
               WRITE setEnableDailymotion480Download
               NOTIFY enableDailymotion480DownloadChanged)
    Q_PROPERTY(bool enableDailymotion384Download
               READ enableDailymotion384Download
               WRITE setEnableDailymotion384Download
               NOTIFY enableDailymotion384DownloadChanged)
    Q_PROPERTY(bool enableVimeo720Playback
               READ enableVimeo720Playback
               WRITE setEnableVimeo720Playback
               NOTIFY enableVimeo720PlaybackChanged)
    Q_PROPERTY(bool enableVimeo360Playback
               READ enableVimeo360Playback
               WRITE setEnableVimeo360Playback
               NOTIFY enableVimeo360PlaybackChanged)
    Q_PROPERTY(bool enableVimeo720Download
               READ enableVimeo720Download
               WRITE setEnableVimeo720Download
               NOTIFY enableVimeo720DownloadChanged)
    Q_PROPERTY(bool enableVimeo360Download
               READ enableVimeo360Download
               WRITE setEnableVimeo360Download
               NOTIFY enableVimeo360DownloadChanged)
    Q_PROPERTY(QString downloadPath
               READ downloadPath
               WRITE setDownloadPath
               NOTIFY downloadPathChanged)
    Q_PROPERTY(bool startTransfersAutomatically
               READ startTransfersAutomatically
               WRITE setStartTransfersAutomatically
               NOTIFY startTransfersAutomaticallyChanged)
    Q_PROPERTY(int maximumConcurrentTransfers
               READ maximumConcurrentTransfers
               WRITE setMaximumConcurrentTransfers
               NOTIFY maximumConcurrentTransfersChanged)
    Q_PROPERTY(int maximumConnectionsPerTransfer
               READ maximumConnectionsPerTransfer
               WRITE setMaximumConnectionsPerTransfer
               NOTIFY maximumConnectionsPerTransferChanged)
    Q_PROPERTY(bool downloadSubtitles
               READ downloadSubtitles
               WRITE setDownloadSubtitles
               NOTIFY downloadSubtitlesChanged)
    Q_PROPERTY(bool safeSearch
               READ safeSearch
               WRITE setSafeSearch
               NOTIFY safeSearchChanged)
    Q_PROPERTY(Services::VideoService searchSite
               READ searchSite
               WRITE setSearchSite
               NOTIFY searchSiteChanged)
    Q_PROPERTY(bool showSearchSite
               READ showSearchSite
               WRITE setShowSearchSite
               NOTIFY showSearchSiteChanged)
    Q_PROPERTY(Queries::QueryOrder searchOrder
               READ searchOrder
               WRITE setSearchOrder
               NOTIFY searchOrderChanged)
    Q_PROPERTY(bool showSearchOrder
               READ showSearchOrder
               WRITE setShowSearchOrder
               NOTIFY showSearchOrderChanged)
    Q_PROPERTY(Queries::TimeFilter searchTime
               READ searchTime
               WRITE setSearchTime
               NOTIFY searchTimeChanged)
    Q_PROPERTY(bool showSearchTime
               READ showSearchTime
               WRITE setShowSearchTime
               NOTIFY showSearchTimeChanged)
    Q_PROPERTY(Queries::DurationFilter searchDuration
               READ searchDuration
               WRITE setSearchDuration
               NOTIFY searchDurationChanged)
    Q_PROPERTY(bool showSearchDuration
               READ showSearchDuration
               WRITE setShowSearchDuration
               NOTIFY showSearchDurationChanged)
    Q_PROPERTY(Queries::QueryType searchType
               READ searchType
               WRITE setSearchType
               NOTIFY searchTypeChanged)
    Q_PROPERTY(bool showSearchType
               READ showSearchType
               WRITE setShowSearchType
               NOTIFY showSearchTypeChanged)
    Q_PROPERTY(QString languageFilter
               READ languageFilter
               WRITE setLanguageFilter
               NOTIFY languageFilterChanged)
    Q_PROPERTY(bool showSearchLanguage
               READ showSearchLanguage
               WRITE setShowSearchLanguage
               NOTIFY showSearchLanguageChanged)
    Q_PROPERTY(QString subtitlesLanguage
               READ subtitlesLanguage
               WRITE setSubtitlesLanguage
               NOTIFY subtitlesLanguageChanged)
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    Q_PROPERTY(QString theme
               READ theme
               WRITE setTheme
               NOTIFY themeChanged)
    Q_PROPERTY(QString activeColor
               READ activeColor
#ifdef SYMBIAN_OS
               CONSTANT)
#else
               WRITE setActiveColor
               NOTIFY activeColorChanged)
#endif
    Q_PROPERTY(QString activeColorString
               READ activeColorString
#ifdef SYMBIAN_OS
               CONSTANT)
#else
               WRITE setActiveColorString
               NOTIFY activeColorStringChanged)
#endif
#endif
    Q_PROPERTY(QString language
               READ language
               WRITE setLanguage
               NOTIFY languageChanged)
    Q_PROPERTY(ScreenOrientation::Orientation screenOrientation
               READ screenOrientation
               WRITE setScreenOrientation
               NOTIFY screenOrientationChanged)
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    Q_PROPERTY(bool fullscreen
               READ fullscreen
               WRITE setFullscreen
               NOTIFY fullscreenChanged)
#endif
    Q_PROPERTY(QString uploadAttribute
               READ uploadAttribute
               WRITE setUploadAttribute
               NOTIFY uploadAttributeChanged)
    Q_PROPERTY(QString mediaPlayer
               READ mediaPlayer
               WRITE setMediaPlayer
               NOTIFY mediaPlayerChanged)
#ifndef SYMBIAN_OS
    Q_PROPERTY(QString mediaPlayerCommand
               READ mediaPlayerCommand
               WRITE setMediaPlayerCommand
               NOTIFY mediaPlayerCommandChanged)
#ifdef CUTETUBE_PLAYER_ENABLED
    Q_PROPERTY(bool backgroundPlaybackEnabled
               READ backgroundPlaybackEnabled
               WRITE setBackgroundPlaybackEnabled
               NOTIFY backgroundPlaybackEnabledChanged)
#endif
#endif
    Q_PROPERTY(bool monitorClipboard
               READ monitorClipboard
               WRITE setMonitorClipboard
               NOTIFY monitorClipboardChanged)
    Q_PROPERTY(NetworkProxyType::ProxyType networkProxyType
               READ networkProxyType
               WRITE setNetworkProxyType
               NOTIFY networkProxyTypeChanged)
    Q_PROPERTY(QString networkProxyTypeString
               READ networkProxyTypeString
               NOTIFY networkProxyTypeStringChanged)
    Q_PROPERTY(QString networkProxyHostName
               READ networkProxyHostName
               WRITE setNetworkProxyHostName
               NOTIFY networkProxyHostNameChanged)
    Q_PROPERTY(quint16 networkProxyPort
               READ networkProxyPort
               WRITE setNetworkProxyPort
               NOTIFY networkProxyPortChanged)
    Q_PROPERTY(QString networkProxyUser
               READ networkProxyUser
               WRITE setNetworkProxyUser
               NOTIFY networkProxyUserChanged)
    Q_PROPERTY(QString networkProxyPassword
               READ networkProxyPassword
               WRITE setNetworkProxyPassword
               NOTIFY networkProxyPasswordChanged)
#ifdef Q_WS_MAEMO_5
    Q_PROPERTY(bool eventFeedEnabled
               READ eventFeedEnabled
               WRITE setEventFeedEnabled
               NOTIFY eventFeedEnabledChanged)
    Q_PROPERTY(bool eventFeedInstalled
               READ eventFeedInstalled
               CONSTANT)
#endif
    Q_PROPERTY(bool cuteTubePlayerEnabled
               READ cuteTubePlayerEnabled
               CONSTANT)
#ifdef IN_APP_UPDATES
    Q_PROPERTY(bool checkForUpdateOnStartup
               READ checkForUpdateOnStartup
               WRITE setCheckForUpdateOnStartup
               NOTIFY checkForUpdateOnStartupChanged)
#endif

public:
    explicit Settings(QObject *parent = 0);
    ~Settings();
    inline QSet<int> youtubePlaybackFormats() const { return m_youtubePlaybackFormats; }
    inline QSet<int> youtubeDownloadFormats() const { return m_youtubeDownloadFormats; }
    inline QSet<int> dailymotionPlaybackFormats() const { return m_dailymotionPlaybackFormats; }
    inline QSet<int> dailymotionDownloadFormats() const { return m_dailymotionDownloadFormats; }
    inline QSet<int> vimeoPlaybackFormats() const { return m_vimeoPlaybackFormats; }
    inline QSet<int> vimeoDownloadFormats() const { return m_vimeoDownloadFormats; }
    inline bool enableYouTube1080Playback() const { return m_youtubePlaybackFormats.contains(Videos::SuperHD); }
    inline bool enableYouTube720Playback() const { return m_youtubePlaybackFormats.contains(Videos::HD); }
    inline bool enableYouTube480Playback() const { return m_youtubePlaybackFormats.contains(Videos::HQ); }
    inline bool enableYouTube360Playback() const { return m_youtubePlaybackFormats.contains(Videos::Normal); }
    inline bool enableYouTubeNormalPlayback() const { return m_youtubePlaybackFormats.contains(Videos::LQ); }
    inline bool enableYouTube240Playback() const { return m_youtubePlaybackFormats.contains(Videos::MobileNormal); }
    inline bool enableYouTube1080Download() const { return m_youtubeDownloadFormats.contains(Videos::SuperHD); }
    inline bool enableYouTube720Download() const { return m_youtubeDownloadFormats.contains(Videos::HD); }
    inline bool enableYouTube480Download() const { return m_youtubeDownloadFormats.contains(Videos::HQ); }
    inline bool enableYouTube360Download() const { return m_youtubeDownloadFormats.contains(Videos::Normal); }
    inline bool enableYouTubeNormalDownload() const { return m_youtubeDownloadFormats.contains(Videos::LQ); }
    inline bool enableYouTube240Download() const { return m_youtubeDownloadFormats.contains(Videos::MobileNormal); }
    inline bool enableDailymotion1080Playback() const { return m_dailymotionPlaybackFormats.contains(Videos::SuperHD); }
    inline bool enableDailymotion720Playback() const { return m_dailymotionPlaybackFormats.contains(Videos::HD); }
    inline bool enableDailymotion480Playback() const { return m_dailymotionPlaybackFormats.contains(Videos::HQ); }
    inline bool enableDailymotion384Playback() const { return m_dailymotionPlaybackFormats.contains(Videos::Normal); }
    inline bool enableDailymotion1080Download() const { return m_dailymotionDownloadFormats.contains(Videos::SuperHD); }
    inline bool enableDailymotion720Download() const { return m_dailymotionDownloadFormats.contains(Videos::HD); }
    inline bool enableDailymotion480Download() const { return m_dailymotionDownloadFormats.contains(Videos::HQ); }
    inline bool enableDailymotion384Download() const { return m_dailymotionDownloadFormats.contains(Videos::Normal); }
    inline bool enableVimeo720Playback() const { return m_vimeoPlaybackFormats.contains(Videos::HD); }
    inline bool enableVimeo360Playback() const { return m_vimeoPlaybackFormats.contains(Videos::Normal); }
    inline bool enableVimeo720Download() const { return m_vimeoDownloadFormats.contains(Videos::HD); }
    inline bool enableVimeo360Download() const { return m_vimeoDownloadFormats.contains(Videos::Normal); }
    inline QString downloadPath() const { return m_path; }
    inline bool startTransfersAutomatically() const { return m_autoTransfers; }
    inline int maximumConcurrentTransfers() const { return m_maxConcurrentTransfers; }
    inline int maximumConnectionsPerTransfer() const { return m_maxConnectionsPerTransfer; }
    inline bool downloadSubtitles() const { return m_downloadSubtitles; }
    inline bool safeSearch() { return m_safeSearch; }
    inline Services::VideoService searchSite() const { return this->showSearchSite() ? m_searchSite : Services::YouTube; }
    inline bool showSearchSite() const { return m_showSearchSite; }
    inline Queries::QueryOrder searchOrder() const { return this->showSearchOrder() ? m_searchOrder : Queries::Relevance; }
    inline bool showSearchOrder() const { return m_showSearchOrder; }
    inline Queries::TimeFilter searchTime() const { return this->showSearchTime() ? m_searchTime : Queries::AllTime; }
    inline bool showSearchTime() const { return m_showSearchTime; }
    inline Queries::DurationFilter searchDuration() const { return this->showSearchDuration() ? m_searchDuration : Queries::Any; }
    inline bool showSearchDuration() const { return m_showSearchDuration; }
    inline Queries::QueryType searchType() const { return this->showSearchType() ? m_searchType : Queries::Videos; }
    inline bool showSearchType() const { return m_showSearchType; }
    inline QString languageFilter() const { return m_languageFilter; }
    inline bool showSearchLanguage() const { return m_showSearchLanguage; }
    inline QString subtitlesLanguage() const { return m_subtitlesLanguage; }
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    inline QString theme() const { return m_theme; }
    inline QString activeColor() const { return m_activeColor; }
    inline QString activeColorString() const { return m_activeColorString; }
#endif
    inline QString language() const { return m_language; }
    inline QString uploadAttribute() const { return m_attribute; }
    inline QString mediaPlayer() const { return m_mediaplayer; }
#ifndef SYMBIAN_OS
    inline QString mediaPlayerCommand() const { return m_command; }
#ifdef CUTETUBE_PLAYER_ENABLED
    inline bool backgroundPlaybackEnabled() const { return m_backgroundPlaybackEnabled; }
#endif
#endif
    inline ScreenOrientation::Orientation screenOrientation() const { return m_orientation; }
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    inline bool fullscreen() const { return m_fullscreen; }
#endif
    inline bool monitorClipboard() const { return m_monitorClipboard; }
    inline NetworkProxyType::ProxyType networkProxyType() const { return m_proxyType; }
    QString networkProxyTypeString() const;
    inline QString networkProxyHostName() const { return m_proxyHost; }
    inline quint16 networkProxyPort() const { return m_proxyPort; }
    inline QString networkProxyUser() const { return m_proxyUser; }
    inline QString networkProxyPassword() const { return m_proxyPass; }
#ifdef Q_WS_MAEMO_5
    inline bool eventFeedEnabled() const { return m_eventFeedEnabled; }
    bool eventFeedInstalled() const;
#endif
    inline bool cuteTubePlayerEnabled() const { return m_cuteTubePlayerEnabled; }
#ifdef IN_APP_UPDATES
    inline bool checkForUpdateOnStartup() const { return m_checkUpdate; }
#endif

    static Settings* instance();

public slots:
    void saveSettings();
    void restoreSettings();
    void setEnableYouTube1080Playback(bool enable);
    void setEnableYouTube720Playback(bool enable);
    void setEnableYouTube480Playback(bool enable);
    void setEnableYouTube360Playback(bool enable);
    void setEnableYouTubeNormalPlayback(bool enable);
    void setEnableYouTube240Playback(bool enable);
    void setEnableYouTube1080Download(bool enable);
    void setEnableYouTube720Download(bool enable);
    void setEnableYouTube480Download(bool enable);
    void setEnableYouTube360Download(bool enable);
    void setEnableYouTubeNormalDownload(bool enable);
    void setEnableYouTube240Download(bool enable);
    void setEnableDailymotion1080Playback(bool enable);
    void setEnableDailymotion720Playback(bool enable);
    void setEnableDailymotion480Playback(bool enable);
    void setEnableDailymotion384Playback(bool enable);
    void setEnableDailymotion1080Download(bool enable);
    void setEnableDailymotion720Download(bool enable);
    void setEnableDailymotion480Download(bool enable);
    void setEnableDailymotion384Download(bool enable);
    void setEnableVimeo720Playback(bool enable);
    void setEnableVimeo360Playback(bool enable);
    void setEnableVimeo720Download(bool enable);
    void setEnableVimeo360Download(bool enable);
    void setDownloadPath(const QString &path);
    void setStartTransfersAutomatically(bool automatic);
    void setMaximumConcurrentTransfers(int maximum);
    void setMaximumConnectionsPerTransfer(int maximum);
    void setDownloadSubtitles(bool download);
    void setSafeSearch(bool safe);
    void setSearchSite(Services::VideoService site);
    void setShowSearchSite(bool show);
    void setSearchOrder(Queries::QueryOrder order);
    void setShowSearchOrder(bool show);
    void setSearchTime(Queries::TimeFilter time);
    void setShowSearchTime(bool show);
    void setSearchDuration(Queries::DurationFilter duration);
    void setShowSearchDuration(bool show);
    void setSearchType(Queries::QueryType type);
    void setShowSearchType(bool show);
    void setLanguageFilter(const QString &language);
    void setShowSearchLanguage(bool show);
    void setSubtitlesLanguage(const QString &language);
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    void setTheme(const QString &theme);
#ifdef MEEGO_EDITION_HARMATTAN
    void setActiveColor(const QString &color);
    void setActiveColorString(const QString &colorString);
#endif
#endif
    void setLanguage(const QString &lang);
    void setUploadAttribute(const QString &attribute);
    void setMediaPlayer(const QString &player);
#ifndef SYMBIAN_OS
    void setMediaPlayerCommand(const QString &command);
#ifdef CUTETUBE_PLAYER_ENABLED
    void setBackgroundPlaybackEnabled(bool enabled);
#endif
#endif
    void setScreenOrientation(ScreenOrientation::Orientation orientation);
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    void setFullscreen(bool fullscreen);
#endif
    void setMonitorClipboard(bool monitor);
    void setNetworkProxyType(NetworkProxyType::ProxyType proxyType);
    void setNetworkProxyHostName(const QString &hostName);
    void setNetworkProxyPort(quint16 port);
    void setNetworkProxyUser(const QString &user);
    void setNetworkProxyPassword(const QString &password);
    void setNetworkProxy();
#ifdef Q_WS_MAEMO_5
    void setEventFeedEnabled(bool enabled);
#endif
#ifdef IN_APP_UPDATES
    void setCheckForUpdateOnStartup(bool check);
#endif

private:
    void setYouTubePlaybackFormats(QVariantList formats);
    void setYouTubeDownloadFormats(QVariantList formats);
    void setDailymotionPlaybackFormats(QVariantList formats);
    void setDailymotionDownloadFormats(QVariantList formats);
    void setVimeoPlaybackFormats(QVariantList formats);
    void setVimeoDownloadFormats(QVariantList formats);
    void setCuteTubePlayerEnabled(bool enabled);
    QVariantList toVariantList(const QSet<int> &set);

private slots:
    void onNetworkProxyAuthenticationRequested(const QNetworkProxy &proxy, QAuthenticator *authenticator);

signals:
    void enableYouTube1080PlaybackChanged();
    void enableYouTube720PlaybackChanged();
    void enableYouTube480PlaybackChanged();
    void enableYouTube360PlaybackChanged();
    void enableYouTubeNormalPlaybackChanged();
    void enableYouTube240PlaybackChanged();
    void enableYouTube1080DownloadChanged();
    void enableYouTube720DownloadChanged();
    void enableYouTube480DownloadChanged();
    void enableYouTube360DownloadChanged();
    void enableYouTubeNormalDownloadChanged();
    void enableYouTube240DownloadChanged();
    void enableDailymotion1080PlaybackChanged();
    void enableDailymotion720PlaybackChanged();
    void enableDailymotion480PlaybackChanged();
    void enableDailymotion384PlaybackChanged();
    void enableDailymotion1080DownloadChanged();
    void enableDailymotion720DownloadChanged();
    void enableDailymotion480DownloadChanged();
    void enableDailymotion384DownloadChanged();
    void enableVimeo720PlaybackChanged();
    void enableVimeo360PlaybackChanged();
    void enableVimeo720DownloadChanged();
    void enableVimeo360DownloadChanged();
    void youtubePlaybackFormatsChanged(const QSet<int> &formats);
    void youtubeDownloadFormatsChanged(const QSet<int> &formats);
    void dailymotionPlaybackFormatsChanged(const QSet<int> &formats);
    void dailymotionDownloadFormatsChanged(const QSet<int> &formats);
    void vimeoPlaybackFormatsChanged(const QSet<int> &formats);
    void vimeoDownloadFormatsChanged(const QSet<int> &formats);
    void downloadPathChanged(const QString &path);
    void startTransfersAutomaticallyChanged(bool automatic);
    void maximumConcurrentTransfersChanged(int oldMaximum, int newMaximum);
    void maximumConnectionsPerTransferChanged(int oldMaximum, int newMaximum);
    void downloadSubtitlesChanged(bool download);
    void safeSearchChanged(bool safe);
    void searchSiteChanged(Services::VideoService service);
    void showSearchSiteChanged(bool show);
    void searchOrderChanged(Queries::QueryOrder order);
    void showSearchOrderChanged(bool show);
    void searchTimeChanged(Queries::TimeFilter time);
    void showSearchTimeChanged(bool show);
    void searchDurationChanged(Queries::DurationFilter duration);
    void showSearchDurationChanged(bool show);
    void searchTypeChanged(Queries::QueryType type);
    void showSearchTypeChanged(bool show);
    void languageFilterChanged(const QString &language);
    void showSearchLanguageChanged(bool show);
    void subtitlesLanguageChanged(const QString &language);
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    void themeChanged(const QString &themeString);
#ifdef MEEGO_EDITION_HARMATTAN
    void activeColorChanged(const QString &color);
    void activeColorStringChanged(const QString &colorString);
#endif
#endif
    void languageChanged(const QString &language);
    void alert(const QString &message);
    void uploadAttributeChanged(const QString &attribute);
    void mediaPlayerChanged(const QString &player);
#ifndef SYMBIAN_OS
    void mediaPlayerCommandChanged(const QString &command);
#ifdef CUTETUBE_PLAYER_ENABLED
    void backgroundPlaybackEnabledChanged(bool enabled);
#endif
#endif
    void screenOrientationChanged(ScreenOrientation::Orientation orientation);
    void fullscreenChanged(bool fullscreen);
    void monitorClipboardChanged(bool monitor);
    void networkProxyTypeChanged(NetworkProxyType::ProxyType proxyType);
    void networkProxyTypeStringChanged(const QString &proxyTypeString);
    void networkProxyHostNameChanged(const QString &hostName);
    void networkProxyPortChanged(quint16 port);
    void networkProxyUserChanged(const QString &user);
    void networkProxyPasswordChanged(const QString &password);
#ifdef Q_WS_MAEMO_5
    void eventFeedEnabledChanged(bool enabled);
#endif
#ifdef IN_APP_UPDATES
    void checkForUpdateOnStartupChanged(bool check);
#endif

private:
    static Settings *self;

    QSet<int> m_youtubePlaybackFormats;
    QSet<int> m_youtubeDownloadFormats;
    QSet<int> m_dailymotionPlaybackFormats;
    QSet<int> m_dailymotionDownloadFormats;
    QSet<int> m_vimeoPlaybackFormats;
    QSet<int> m_vimeoDownloadFormats;
    QString m_path;
    bool m_autoTransfers;
    int m_maxConcurrentTransfers;
    int m_maxConnectionsPerTransfer;
    bool m_downloadSubtitles;
    bool m_safeSearch;
    Services::VideoService m_searchSite;
    bool m_showSearchSite;
    Queries::QueryOrder m_searchOrder;
    bool m_showSearchOrder;
    Queries::TimeFilter m_searchTime;
    bool m_showSearchTime;
    Queries::DurationFilter m_searchDuration;
    bool m_showSearchDuration;
    Queries::QueryType m_searchType;
    bool m_showSearchType;
    QString m_languageFilter;
    bool m_showSearchLanguage;
    QString m_subtitlesLanguage;
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    QString m_theme;
    QString m_activeColor;
    QString m_activeColorString;
#endif
    QString m_language;
    QString m_attribute;
    QString m_mediaplayer;
#ifndef SYMBIAN_OS
    QString m_command;
#ifdef CUTETUBE_PLAYER_ENABLED
    bool m_backgroundPlaybackEnabled;
#endif
#endif
    ScreenOrientation::Orientation m_orientation;
#if (defined (SYMBIAN_OS) || (defined (MEEGO_EDITION_HARMATTAN)))
    bool m_fullscreen;
#endif
    bool m_monitorClipboard;
    NetworkProxyType::ProxyType m_proxyType;
    QString m_proxyTypeString;
    QString m_proxyHost;
    quint16 m_proxyPort;
    QString m_proxyUser;
    QString m_proxyPass;
#ifdef Q_WS_MAEMO_5
    bool m_eventFeedEnabled;
    bool m_eventFeedInstalled;
#endif
    bool m_cuteTubePlayerEnabled;
#ifdef IN_APP_UPDATES
    bool m_checkUpdate;
#endif
};

#endif // SETTINGS_H
