#ifndef PLAYBACKQUALITYDIALOG_H
#define PLAYBACKQUALITYDIALOG_H

#include "abstractdialog.h"

class QCheckBox;
class QGridLayout;
class QDialogButtonBox;
class QScrollArea;

class PlaybackFormatDialog : public AbstractDialog
{
    Q_OBJECT

public:
    explicit PlaybackFormatDialog(QWidget *parent = 0);

private slots:
    void saveSettings();

private:
    void loadSettings();
    void setLandscapeLayout();
    void setPortraitLayout();
    
private:
    QCheckBox *m_youtube720Checkbox;
    QCheckBox *m_youtube480Checkbox;
    QCheckBox *m_youtube360Checkbox;
    QCheckBox *m_youtubeNormalCheckbox;
    QCheckBox *m_youtube240Checkbox;
    QCheckBox *m_youtube144Checkbox;
    QCheckBox *m_dailymotion720Checkbox;
    QCheckBox *m_dailymotion480Checkbox;
    QCheckBox *m_dailymotion384Checkbox;
    QCheckBox *m_dailymotion240Checkbox;
    QCheckBox *m_vimeo720Checkbox;
    QCheckBox *m_vimeo360Checkbox;
    QCheckBox *m_vimeoMobileCheckbox;
    QDialogButtonBox *m_buttonBox;
    QScrollArea *m_scrollArea;
    QGridLayout *m_grid;
};

#endif // PLAYBACKQUALITYDIALOG_H
