#ifndef SEARCHOPTIONSDIALOG_H
#define SEARCHOPTIONSDIALOG_H

#include "abstractdialog.h"

class QCheckBox;
class QDialogButtonBox;
class QScrollArea;
class QGridLayout;

class SearchOptionsDialog : public AbstractDialog
{
    Q_OBJECT
public:
    explicit SearchOptionsDialog(QWidget *parent = 0);

private slots:
    void saveSettings();
    
private:
    void loadSettings();
    void setLandscapeLayout();
    void setPortraitLayout();

private:
    QCheckBox *m_serviceCheckbox;
    QCheckBox *m_typeCheckbox;
    QCheckBox *m_orderCheckbox;
    QCheckBox *m_timeCheckbox;
    QCheckBox *m_durationCheckbox;
    QCheckBox *m_languageCheckbox;
    QDialogButtonBox *m_buttonBox;
    QScrollArea *m_scrollArea;
    QGridLayout *m_grid;
};

#endif // SEARCHOPTIONSDIALOG_H
