#include "videowidget.h"

VideoWidget::VideoWidget(QWidget *parent) :
    QVideoWidget(parent)
{
    this->setFocusPolicy(Qt::NoFocus);
}

void VideoWidget::mousePressEvent(QMouseEvent *event) {
    m_pressed = true;
    event->accept();
}

void VideoWidget::mouseReleaseEvent(QMouseEvent *event) {
    if (m_pressed) {
        emit clicked();
        event->accept();
    }

    m_pressed = false;
}

void VideoWidget::toggleAspectRatioMode() {
    switch (this->aspectRatioMode()) {
    case Qt::KeepAspectRatio:
        this->setAspectRatioMode(Qt::KeepAspectRatioByExpanding);
        break;
    case Qt::KeepAspectRatioByExpanding:
        this->setAspectRatioMode(Qt::IgnoreAspectRatio);
        break;
    default:
        this->setAspectRatioMode(Qt::KeepAspectRatio);
        break;
    }
}
