#ifndef VIMEOSUBSCRIPTIONSTAB_H
#define VIMEOSUBSCRIPTIONSTAB_H

#include "abstracttab.h"

class VimeoSubscriptionListModel;
class ListView;
class QMenu;
class QAction;
class QLabel;
class QGridLayout;
class QModelIndex;

class VimeoSubscriptionsTab : public AbstractTab
{
    Q_OBJECT
public:
    explicit VimeoSubscriptionsTab(QWidget *parent = 0);

private:
    void setLandscapeLayout();
    void setPortraitLayout();

private slots:
    void onSubscriptionsLoaded();
    void onCountChanged(int count);
    void onItemClicked(const QModelIndex &index);
    void showContextMenu(const QPoint &pos);
    void unsubscribe();
    void showUserChannel(const QString &userId);
    void showSubscriptionVideos();

private:
    VimeoSubscriptionListModel *m_model;
    ListView *m_listView;
    QMenu *m_contextMenu;
    QAction *m_unsubscribeAction;
    QAction *m_videosAction;
    QLabel *m_noResultsLabel;
    QGridLayout *m_grid;
};

#endif // VIMEOSUBSCRIPTIONSTAB_H
