#ifndef YOUTUBEUSERPLAYLISTLISTTAB_H
#define YOUTUBEUSERPLAYLISTLISTTAB_H

#include "abstracttab.h"
#include "../base/playlistitem.h"

class ListView;
class YouTubeUserPlaylistListModel;
class QLabel;
class QMenu;
class QAction;
class QGridLayout;
class QModelIndex;

class YouTubeUserPlaylistListTab : public AbstractTab
{
    Q_OBJECT

public:
    explicit YouTubeUserPlaylistListTab(QWidget *parent = 0);

private:
    void setLandscapeLayout();
    void setPortraitLayout();

private slots:
    void onPlaylistsLoaded();
    void onCountChanged(int count);
    void onItemClicked(const QModelIndex &index);
    void showPlaylist(QSharedPointer<PlaylistItem> playlist);
    void showContextMenu(const QPoint &pos);
    void deletePlaylist();
    void showNewPlaylistDialog();

private:
    ListView *m_listView;
    YouTubeUserPlaylistListModel *m_model;
    QMenu *m_contextMenu;
    QAction *m_deleteAction;
    QAction *m_newPlaylistAction;
    QLabel *m_noResultsLabel;
    QGridLayout *m_grid;
};

#endif // YOUTUBEUSERPLAYLISTLISTTAB_H
