#ifndef YOUTUBEVIDEOINFOWINDOW_H
#define YOUTUBEVIDEOINFOWINDOW_H

#include "stackedwindow.h"
#include "../base/videoitem.h"

class YouTubeVideoDescriptionTab;
class YouTubeVideoCommentsTab;
class YouTubeRelatedVideosTab;
class QStackedWidget;
class QActionGroup;
class QMenu;

class YouTubeVideoInfoWindow : public StackedWindow
{
    Q_OBJECT

public:
    explicit YouTubeVideoInfoWindow(QSharedPointer<VideoItem> video, QWidget *parent);

private:
    void clearMenuActions();

private slots:
    void showInfo();
    void showComments();
    void showRelatedVideos();

private:
    QSharedPointer<VideoItem> m_video;
    QMenu *m_menu;
    QActionGroup *m_actionGroup;
    QAction *m_infoAction;
    QAction *m_commentsAction;
    QAction *m_relatedAction;
    QStackedWidget *m_tabWidget;
    YouTubeVideoDescriptionTab *m_infoTab;
    YouTubeVideoCommentsTab *m_commentsTab;
    YouTubeRelatedVideosTab *m_relatedTab;
};

#endif // YOUTUBEVIDEOINFOWINDOW_H
